<?php
// Own namespace
namespace Org\Mxchange\CoreFramework\Handler;

// Import framework stuff
use Org\Mxchange\CoreFramework\Criteria\Storing\StoreableCriteria;
use Org\Mxchange\CoreFramework\Handler\DataSet\HandleableDataSet;
use Org\Mxchange\CoreFramework\Object\BaseFrameworkSystem;

/**
 * A general Handler
 *
 * @author		Roland Haeder <webmaster@shipsimu.org>
 * @version		0.0.0
 * @copyright	Copyright (c) 2007, 2008 Roland Haeder, 2009 - 2022 Core Developer Team
 * @license		GNU GPL 3.0 or any newer version
 * @link		http://www.shipsimu.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
abstract class BaseHandler extends BaseFrameworkSystem implements HandleableDataSet {
	/**
	 * Handler name
	 */
	private $handlerName = 'invalid';

	/**
	 * Protected constructor
	 *
	 * @param	$className	Name of the class
	 * @return	void
	 */
	protected function __construct (string $className) {
		// Call parent constructor
		parent::__construct($className);
	}

	/**
	 * Getter for handler name
	 *
	 * @return	$handlerName	Name of this handler
	 */
	public final function getHandlerName () {
		return $this->handlerName;
	}

	/**
	 * Setter for handler name
	 *
	 * @param	$handlerName	Name of this handler
	 * @return	void
	 */
	protected final function setHandlerName (string $handlerName) {
		$this->handlerName = $handlerName;
	}

	/**
	 * Adds all required elements from given array into data set instance
	 *
	 * @param	$dataSetInstance	An instance of a StoreableCriteria class
	 * @param	$messageData		An array with all message data
	 * @return	void
	 * @todo	Rewrite this to use DHT
	 */
	public function addArrayToDataSet (StoreableCriteria $dataSetInstance, array $messageData) {
	}

}
